package com.dxhy.core.controller.mailGather;

import cn.hutool.core.codec.Base64;
import com.alibaba.fastjson.JSONObject;
import com.dxhy.common.controller.AbstractController;
import com.dxhy.common.utils.Base64Encoding;
import com.dxhy.common.utils.R;
import com.dxhy.common.vo.UserInfo;
import com.dxhy.core.model.mailGather.EmailMaintainVo;
import com.dxhy.core.service.mailGather.EmailMaintainService;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.Map;

/**
 * (EmailMaintain)表控制层
 *
 * @author makejava
 * @since 2023-03-23 08:39:46
 */
@Slf4j
@RestController
@RequestMapping("/emailMaintain")
public class EmailMaintainController extends AbstractController  {
    /**
     * 服务对象
     */
    @Resource
    private EmailMaintainService emailMaintainService;

    /**
     * 分页查询
     *
     * @param pramsMap 筛选条件
     * @return 查询结果
     */
    @PostMapping("/queryByPage")
    public ResponseEntity<R> queryByPage(@RequestBody Map<String, Object> pramsMap) {
        // 入参统一在入口处理
//        pramsMap.put("dbName", getUserInfo().getDbName());
//        List<String> gfshList = new ArrayList<>();
//        if (!"99".equals(pramsMap.get("gfsh")) && pramsMap.get("gfsh") != null && !"".equals(pramsMap.get("gfsh"))) {
//            gfshList.add(pramsMap.get("gfsh").toString());
//        } else {
//            gfshList = UserInfoUtil.getGfshAll(getUserInfo().getOrg());
//            if (gfshList.size() == 0) {
//                return ResponseEntity.ok(R.ok().put("data", ""));
//            }
//        }
        Object deptId = pramsMap.get("deptId");
        if(deptId == null || "".equals(String.valueOf(deptId))){
            return ResponseEntity.ok(R.error("查询参数有误！"));
        }
        if("99".equals(String.valueOf(deptId))){
            pramsMap.put("deptId","");
        }
        UserInfo userInfo = getUserInfo();
        log.debug("用户信息：{}", JSONObject.toJSONString(userInfo));
        String loginname = getUserInfo().getLoginname();
        pramsMap.put("createUser",loginname);
        return ResponseEntity.ok(R.ok().put("data",this.emailMaintainService.queryByPage(pramsMap)));
    }

    /**
     * 新增数据
     *
     * @param emailMaintain 实体
     * @return 新增结果
     */
    @PostMapping("/add")
    public ResponseEntity<R> add(@RequestBody EmailMaintainVo emailMaintain) {
        if(StringUtils.isBlank(emailMaintain.getEmailPassword()) || StringUtils.isBlank(emailMaintain.getEmailAddress()) ){
            return ResponseEntity.ok(R.error("邮箱地址/密码不能为空！"));
        }else {
            String encode = Base64Encoding.encode(emailMaintain.getEmailPassword());
            emailMaintain.setEmailPassword(encode);
        }
        String loginname = getUserInfo().getLoginname();
        emailMaintain.setCreateUser(loginname);
        boolean insert = this.emailMaintainService.insert(emailMaintain);
        if(insert){
            return ResponseEntity.ok(R.ok());
        }
        return ResponseEntity.ok(R.error());
    }

    /**
     * 编辑数据
     *
     * @param emailMaintain 实体
     * @return 编辑结果
     */
    @PostMapping("/edit")
    public ResponseEntity<R> edit(@RequestBody  EmailMaintainVo emailMaintain) {
        boolean b = emailMaintainService.update(emailMaintain);
        if(b){
            return ResponseEntity.ok(R.ok());
        }
        return ResponseEntity.ok(R.error());
    }


    /**
     * 编辑数据
     *
     * @param emailMaintain 实体
     * @return 编辑结果
     */
    @PostMapping("/emailUpload")
    public ResponseEntity<R> emailUpload(@RequestBody  EmailMaintainVo emailMaintain) {
        boolean b = emailMaintainService.update(emailMaintain);
        if(b){
            return ResponseEntity.ok(R.ok());
        }
        return ResponseEntity.ok(R.error());
    }



    /**
     * 编辑数据
     *
     * @param paramsMap 实体
     * @return 编辑结果
     */
    @PostMapping("/getUserName")
    public ResponseEntity<R> getUserName(@RequestBody  Map<String,String> paramsMap) {
        String userCode = paramsMap.get("userCode");
        if(StringUtils.isEmpty(userCode)){
            return ResponseEntity.ok(R.error("数据不能为空！"));
        }
        String userName = emailMaintainService.getUserName(userCode);
        if(StringUtils.isNotEmpty(userName)){
            JSONObject json = new JSONObject();
            json.put("datalist", userName);
            log.debug("返回结果：{}", json.toJSONString());
            String jsonString = Base64.encode(json.toJSONString());
            return ResponseEntity.ok(R.ok().put("data",jsonString));
        }
        return ResponseEntity.ok(R.error("未查询到相应数据！"));
    }

}

